# Copyright (c) 2002 Xavier Trochu
#
# This software is provided 'as-is', without any express or implied warranty. In no event
# will the authors be held liable for any damages arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose, including commercial 
# applications, and to alter it and redistribute it freely, subject to the following 
# restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not claim that you 
#    wrote the original software. If you use this software in a product, an acknowledgment 
#    in the product documentation would be appreciated but is not required.
#
# 2. Altered source versions must be plainly marked as such, and must not be misrepresented 
#    as being the original software.
#
# 3. This notice may not be removed or altered from any source distribution.

import os, popen2, sys

def check(name):
	command = sys.argv[1] + ' -nowait -wnd ' + name
	output, input, errput = popen2.popen3(command)
	input.close()
	out = ""
	err = ""
	while 1:
		data = output.read(32768)
		if not len(data):
			break
		out = out + data
	output.close()
	while 1:
		data = errput.read(32768)
		if not len(data):
			break
		err = err + data
	errput.close()
	index = name.rfind(os.sep)
	if index != -1:
		name = name[index+1:]
	index = name.rfind('.')
	if index != -1:
		name = name[:index]
	log = open(name + '.log', 'w')
	log.write('STANDARD ERROR : \n')
	log.write((80 * '=') + '\n')
	log.write(err)
	log.write((80 * '=') + '\n')
	log.write('STANDARD OUTPUT : \n')
	log.write((80 * '=') + '\n')
	log.write(out)
	log.write((80 * '=') +'\n')
	log.close()

def myfilterSmush(name):
	if len(name) < 4:
		return 0
	if name[-4:] == '.SAN' or name[-4:] == '.NUT':
		return 1
	return 0

def check_path(path):
	list = filter(myfilterSmush, os.listdir(path))
	for file in list:
		print 'Checking ' + path + os.sep + file
		check(path + os.sep + file)

def main():
	check_path('G:\\Project\\scummvm\\games\\ft')
	check_path('G:\\Project\\scummvm\\games\\ft\\DATA')
	check_path('G:\\Project\\scummvm\\games\\ft\\VIDEO')
	check_path('G:\\Project\\scummvm\\games\\dig')
	check_path('G:\\Project\\scummvm\\games\\dig\\VIDEO')

if __name__ == '__main__':
	main()
