/*
Copyright (c) 2002 Xavier Trochu

This software is provided 'as-is', without any express or implied warranty. In no event
will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial
applications, and to alter it and redistribute it freely, subject to the following
restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you
   wrote the original software. If you use this software in a product, an acknowledgment
   in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented 
   as being the original software.

3. This notice may not be removed or altered from any source distribution.
*/
#ifndef __CHUNCK_TYPE_H
#define __CHUNCK_TYPE_H

#include "chunck.h"

#define MAKE_TYPE(a,b,c,d) static_cast<chunck::type>( ((a) << 24) | ((b) << 16) | ((c) << 8) | (d) )

static const chunck::type TYPE_ANIM = MAKE_TYPE('A', 'N', 'I', 'M');
static const chunck::type TYPE_AHDR = MAKE_TYPE('A', 'H', 'D', 'R');
static const chunck::type TYPE_FRME = MAKE_TYPE('F', 'R', 'M', 'E');
static const chunck::type TYPE_NPAL = MAKE_TYPE('N', 'P', 'A', 'L');
static const chunck::type TYPE_FOBJ = MAKE_TYPE('F', 'O', 'B', 'J');
static const chunck::type TYPE_PSAD = MAKE_TYPE('P', 'S', 'A', 'D');
static const chunck::type TYPE_TRES = MAKE_TYPE('T', 'R', 'E', 'S');
static const chunck::type TYPE_XPAL = MAKE_TYPE('X', 'P', 'A', 'L');
static const chunck::type TYPE_IACT = MAKE_TYPE('I', 'A', 'C', 'T');
static const chunck::type TYPE_STOR = MAKE_TYPE('S', 'T', 'O', 'R');
static const chunck::type TYPE_FTCH = MAKE_TYPE('F', 'T', 'C', 'H');
static const chunck::type TYPE_SKIP = MAKE_TYPE('S', 'K', 'I', 'P');
static const chunck::type TYPE_STRK = MAKE_TYPE('S', 'T', 'R', 'K');
static const chunck::type TYPE_SMRK = MAKE_TYPE('S', 'M', 'R', 'K');
static const chunck::type TYPE_SHDR = MAKE_TYPE('S', 'H', 'D', 'R');
static const chunck::type TYPE_SDAT = MAKE_TYPE('S', 'D', 'A', 'T');
static const chunck::type TYPE_SAUD = MAKE_TYPE('S', 'A', 'U', 'D');
static const chunck::type TYPE_iMUS = MAKE_TYPE('i', 'M', 'U', 'S');
static const chunck::type TYPE_FRMT = MAKE_TYPE('F', 'R', 'M', 'T');
static const chunck::type TYPE_TEXT = MAKE_TYPE('T', 'E', 'X', 'T');
static const chunck::type TYPE_REGN = MAKE_TYPE('R', 'E', 'G', 'N');
static const chunck::type TYPE_STOP = MAKE_TYPE('S', 'T', 'O', 'P');
static const chunck::type TYPE_MAP_ = MAKE_TYPE('M', 'A', 'P', ' ');
static const chunck::type TYPE_DATA = MAKE_TYPE('D', 'A', 'T', 'A');
static const chunck::type TYPE_ETRS = MAKE_TYPE('E', 'T', 'R', 'S');

#undef MAKE_TYPE

#endif
