/*
Copyright (c) 2002 Xavier Trochu

This software is provided 'as-is', without any express or implied warranty. In no event
will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial
applications, and to alter it and redistribute it freely, subject to the following
restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you
   wrote the original software. If you use this software in a product, an acknowledgment
   in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented 
   as being the original software.

3. This notice may not be removed or altered from any source distribution.
*/
#include "codec1.h"
#include "chunck.h"
#include "blitter.h"

#ifdef DEBUG
#include <iostream>
#endif

using namespace std;

codec1_decoder::~codec1_decoder() throw() {
}

/*
bool codec1_decoder::decode(blitter & dst, chunck & src) throw(exception) {
#ifdef DEBUG
	cout << "codec1_decoder::decode()" << endl;
	try {
#endif
		int width = get_width();
		int height = get_height();
#ifdef DEBUG_CODEC1
		int decoded_size = 0;
		int coded_size = 0;
#endif
		int size = width * height;
		int coded_length = src.get_size() - 14;
		
		while(coded_length > 1 && size > 0) {
			int code = src.get_byte();
			int length = (code >> 1) + 1;
			size -= length;
#ifdef DEBUG_CODEC1
			decoded_size += length;
			coded_size += 1 + ((code & 1) ? 1 : length);
			cout << "decodeCodec1() : code == " << code 
				<< " : length == " << length 
				<< " : decoded_size == " << decoded_size 
				<<  " : coded_size == " << coded_size 
				<<  " : seek - header == " << src.tell() - 15
				<<  " : size == " << size + decoded_size
				<<  " : coded_length == " << coded_length
				<< endl;
#endif
			if(code & 1) {
				coded_length -= 2;
				char color = src.get_char();
				dst.put(color, length);
			} else {
				if(length + 1 > coded_length) length = coded_length - 1;
				coded_length -= 1 + length;
				while(length--) {
					dst.put(src.get_char());
				}
			}
		}
#ifdef DEBUG
	} catch(const exception & e) {
		cout << "Exception occured during decodeCodec1() : " << e.what() << endl;
	}
#endif
}

*/

bool codec1_decoder::decode(blitter & dst, chunck & src) throw(exception) {
	int val;
	int size_line;
	int code, length;
	int h, height = get_rect().height();
	
	for(h = 0; h < height; h++)
	{
		size_line = src.get_word(); // size of compressed line !
#ifdef DEBUG_CODEC1
		cout << "codec1 : h == " << h << " : size_line == " << size_line << endl;
#endif
		while(size_line > 0) {
			code = src.get_byte();
			size_line --;
			length = (code >> 1) + 1;
#ifdef DEBUG_CODEC1
		cout << "codec1 : length == " << length << endl;
#endif
			if(code & 1) {
				val = src.get_byte();
				size_line --;
				if(val) dst.put(val, length);
				else dst.advance(length);
#ifdef DEBUG_CODEC1
		cout << "codec1 : blitting " << length << " times " << val << endl;
#endif
			} else {
				size_line -= length;
#ifdef DEBUG_CODEC1
		cout << "codec1 : blitting " << length << " entries" << endl;
#endif
				while(length--) {
					val = src.get_byte();
					if(val) dst.put(val);
					else dst.advance();
				}
			}
		}
	}
#ifdef DEBUG_CODEC1
	if(!src.eof()) {
		int len = src.get_size() - src.tell();
		cout << "codec1: remaining length after decode == " << len << endl;
	}
#endif
	return true;
}
