/*
Copyright (c) 2002 Xavier Trochu

This software is provided 'as-is', without any express or implied warranty. In no event
will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial
applications, and to alter it and redistribute it freely, subject to the following
restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you
   wrote the original software. If you use this software in a product, an acknowledgment
   in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented 
   as being the original software.

3. This notice may not be removed or altered from any source distribution.
*/
#include "codec44.h"
#include "chunck.h"
#include "blitter.h"

#ifdef DEBUG
#include <iostream>
#endif

using namespace std;

bool codec44_decoder::decode(blitter & dst, chunck & src) throw(exception) {
	//~ int val;
	int size_line;
	int num;
	int w, width = get_rect().width()+1;
	int h, height = get_rect().height()+1;
	bool zero;
#ifdef DEBUG_CODEC44
	cout << "codec44 : " << width << "x" << height << endl;
#endif

	for(h = 0; h < height-1; h++)
	{
		w = width;
		size_line = src.get_word(); // size of compressed line !
#ifdef DEBUG_CODEC44
		cout << "codec44 : h == " << h << " : size_line == " << size_line << endl;
#endif
		zero = true;
		while(size_line > 1) {
			num = src.get_word();
			size_line -= 2;
			if(zero) {
#ifdef DEBUG_CODEC44
				cout << "codec44 : zeroing " << num << " entries" << endl;
#endif
				if(w == num) num--;
				w -= num;
				if(num) dst.put(0, num);
			} else {
				num += 1;
#ifdef DEBUG_CODEC44
				cout << "codec44 : blitting " << num << " entries" << endl;
#endif
				if(w == num) num--;
				w -= num;
				dst.blit(src, num);
				size_line -= num;
			}
			zero = !zero;
		}
	}
	return true;
}
