/*
Copyright (c) 2002 Xavier Trochu

This software is provided 'as-is', without any express or implied warranty. In no event
will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial
applications, and to alter it and redistribute it freely, subject to the following
restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you
   wrote the original software. If you use this software in a product, an acknowledgment
   in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented 
   as being the original software.

3. This notice may not be removed or altered from any source distribution.
*/
#ifndef __ENDIAN_H_
#define __ENDIAN_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

inline unsigned int from_big_endian(unsigned int src) {
	unsigned int a,b,c,d;
	a = (src & 0xFF);
	b = (src & 0xFF00) >> 8;
	c = (src & 0xFF0000) >> 16;
	d = (src & 0xFF000000) >> 24;
	return a << 24 | b << 16 | c << 8 | d;
}

inline unsigned short from_big_endian(unsigned short src) {
	unsigned short a,b;
	a = (src & 0xFF);
	b = (src & 0xFF00) >> 8;
	return a << 8 | b;
}

#endif
