/*
Copyright (c) 2002 Xavier Trochu

This software is provided 'as-is', without any express or implied warranty. In no event
will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial
applications, and to alter it and redistribute it freely, subject to the following
restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you
   wrote the original software. If you use this software in a product, an acknowledgment
   in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented 
   as being the original software.

3. This notice may not be removed or altered from any source distribution.
*/
#include "palette.h"

using namespace std;

palette::palette() throw(exception) : _colors(256) {
}

palette::palette(unsigned char * ptr) throw(exception) : _colors(256) {
	for(int i = 0; i < 256; i++) {
		_colors[i] = color(ptr[3*i+0], ptr[3*i+1], ptr[3*i+2]);
	}
}

palette::palette(const palette & p) throw(exception) : _colors(256) {
	_colors = p._colors;
}

const color & palette::operator[](int a) const throw(exception) {
	return _colors.at(a);
}

color & palette::operator[](int a) throw(exception) {
	return _colors.at(a);
}

palette & palette::operator=(const palette & p) throw() {
	_colors = p._colors;
	return *this;
}

ostream & operator <<(ostream & o, const palette & p) {
	o << "PALETTE[" << endl;
	for(int i = 0; i < 256; i++)
	{
		o << "\t" << i << " = " << p[i] << endl;
	}
	o << "]" << endl;
	return o;
}
